﻿Public Class Form1
    'maderad.boolの値をRadioButtonのチェック状態として取得します。
    Dim space1 As Bitmap
    Dim space2 As Bitmap
    Const pictx1 As Integer = 200      'PictureBox1.LocationのＸ座標
    Const picty1 As Integer = 152     'PictureBox1.LocationのY座標
    Const pictx2 As Integer = 200      'PictureBox2.LocationのＸ座標
    Const picty2 As Integer = 150      'PictureBox2.LocationのY座標
    Const sz As Integer = 18          'PictureBox1.Size
    Const szex As Integer = 90       'PictureBox2の幅
    Const szey As Integer = 20        'PictureBox2の高さ
    Const cntrlnme As String = "Repeat"
    Dim maderad As New radbtn         'Class radbtnのインスタンス



    Dim flework As New dofile               'Class dofileのインスタンス
    Dim checindex As Integer                'チェックしたインデックス
    Dim indexcount As Integer               'チェックしたインデックスの値の取得
    Dim arnme As New List(Of String)        'ファイルのリスト
    Dim selectindx As New List(Of Integer)  'チェックしたインデックスのリスト
    Private Sub f() Handles MyBase.Shown

        '各ボタンの状態の変更
        Button2.Enabled = False
        Button3.Enabled = False
        Button4.Enabled = False

        CheckedListBox1.Items.Clear()

        'MediaPlayerを非表示にする（デザイナー画面でも変更できます）
        AxWindowsMediaPlayer1.Visible = False

        '音楽ファイルをCheckedListBoxに表示
        flework.search()       'ファイルの読み込み
        Dim item() As String   '各項目の配列

        'flework.arlstはClass dofileで作成したコレクションです。
        For Each str As String In flework.arlst
            str = str.Replace("""", "")          '""を取る
            item = str.Split(",")                'strをカンマで区切る
            CheckedListBox1.Items.Add(item(1))   'CheckedListBoxにitem(1)を表示
            arnme.Add(item(0))                   'arnmeにitem(0)をAddする
        Next

        pictrad()  'RadioButtonをPictureBoxに表示するメソッド

    End Sub
    '再生
    Private Sub Button1_Click() Handles Button1.Click
        If selectindx.Count = 0 Then
            MsgBox("ファイルが選択されていません。")
            Return
        End If

        '再生のメソッド
        doplay()
    End Sub
    'Timer1_Tickイベント
    Private Sub Timer1_Tick() Handles Timer1.Tick
        '再生位置をスクロールバーのValueへ入力します。
        HScrollBar1.Value = AxWindowsMediaPlayer1.Ctlcontrols.currentPosition
    End Sub
    'HScrollBar1_Scrollイベント
    Private Sub HScrollBar1_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        '再生位置にスクロールを移動した位置を入力
        AxWindowsMediaPlayer1.Ctlcontrols.currentPosition = CDbl(HScrollBar1.Value)
    End Sub
    '停止
    Private Sub Button2_Click() Handles Button2.Click
        AxWindowsMediaPlayer1.Ctlcontrols.stop()

        '各ボタンの状態の変更
        Button1.Enabled = True
        Button2.Enabled = False
        Button3.Enabled = False
        Button4.Enabled = False
    End Sub
    '一時停止
    Private Sub Button4_Click() Handles Button4.Click
        '一時停止した位置をonestopに代入(HScrollBar1_Scrollが無いときは必要)
        AxWindowsMediaPlayer1.Ctlcontrols.pause()

        '各ボタンの状態の変更
        Button1.Enabled = True
        Button2.Enabled = False
        Button3.Enabled = False
    End Sub
    'スキップ
    Private Sub Button3_Click() Handles Button3.Click
        If indexcount = 1 Then
            MsgBox("次のファイルは選択されていません。")
            Return
        End If

        '次の曲
        AxWindowsMediaPlayer1.Ctlcontrols.next()
    End Sub
    'AxWindowsMediaPlayer1_PlayStateChangeイベントハンドラ
    Private Sub AxWindowsMediaPlayer1_PlayStateChange(sender As System.Object, _
            e As AxWMPLib._WMPOCXEvents_PlayStateChangeEvent) Handles AxWindowsMediaPlayer1.PlayStateChange
        '演奏中
        If e.newState = 3 Then
            Timer1.Enabled = True 'Timer1のスタート
            Timer1.Interval = 1   'Timer1のインターバル

            'HScrollBar1の上限最大値を入力する  + 1は上限最大値を少し超える場合があるため
            HScrollBar1.Maximum = CInt(AxWindowsMediaPlayer1.currentMedia.duration) + 1

            Dim artnme As String  'アーティスト名
            Dim title As String   'タイトル
            Dim madetime As String = ""  '年月日
            Dim tim As String     '演奏時間
            Dim itemtime() As String   '演奏時間の分と秒の項目の配列
            Dim pas As String     'ファイルのフルパス
            Dim item() As String   '各項目の配列

            '各値を取得
            artnme = AxWindowsMediaPlayer1.currentMedia.getItemInfo("Author")
            title = AxWindowsMediaPlayer1.currentMedia.name
            tim = AxWindowsMediaPlayer1.currentMedia.durationString
            itemtime = tim.Split(":")

            pas = AxWindowsMediaPlayer1.currentMedia.sourceURL.ToString
            For Each str As String In flework.arlst
                str = str.Replace("""", "")
                item = str.Split(",")
                If item(0) = pas Then
                    madetime = item(2)
                End If
            Next

            With ListBox1.Items
                .Clear()        'ListBox1のクリア

                .Add("アーティスト" & "   " & artnme)
                .Add("タイトル    " & "   " & title)
                .Add("年          " & "   " & madetime)
                .Add("演奏時間    " & "" & itemtime(0) & "分" & "  " & itemtime(1) & "秒")
                .Add("ファイルパス" & "   " & pas)
            End With
        End If

        '演奏終了
        If e.newState = 8 Then '登録ファイルが1個の場合e.newStateの戻り値が8の時の処理
            Timer1.Enabled = False 'Timer1の監視を停止
            HScrollBar1.Value = 0  '演奏が終了したらスクロールバーを初期状態にする
            If maderad.bool = True Then
                '再生のメソッド
                doplay()
            ElseIf maderad.bool = False Then
                '各ボタンの状態の変更
                Button1.Enabled = True
                Button2.Enabled = True
                Button3.Enabled = True
                Button4.Enabled = True
            End If

        ElseIf e.newState = 1 Then  '登録ファイルが1個の場合e.newStateの戻り値が1の時の処理
            Timer1.Enabled = False 'Timer1の監視を停止
            HScrollBar1.Value = 0  '演奏が終了したらスクロールバーを初期状態にする
            If maderad.bool = True Then
                If indexcount = 1 Then '登録ファイルが1個の場合の処理
                    '再生のメソッド
                    doplay()
                ElseIf maderad.bool = False Then
                    '各ボタンの状態の変更
                    Button1.Enabled = True
                    Button2.Enabled = False
                    Button3.Enabled = False
                    Button4.Enabled = False
                End If
            End If
        End If
    End Sub
    'CheckedListBox1_ItemCheckイベント
    Private Sub CheckedListBox1_ItemCheck(sender As System.Object, _
         e As System.Windows.Forms.ItemCheckEventArgs) Handles CheckedListBox1.ItemCheck

        'CheckedListBox1で選んだファイルのインデックス
        checindex = CheckedListBox1.SelectedIndex
        'チェックされた場合リストに追加(Add)
        If e.CurrentValue = 0 Then
            selectindx.Add(checindex)
        End If
        'チェックが外された場合リストから削除(Remove)
        If e.CurrentValue = 1 Then
            selectindx.Remove(checindex)
        End If

        selectindx.Sort()   'selectindxを数字の小さい順にソートする（クイックソート）

        'currentPlaylistのクリア
        AxWindowsMediaPlayer1.currentPlaylist.clear()

        Dim indexnum As Integer
        'チェックしたインデックスのリストの数をカウントする 
        indexcount = selectindx.Count
        For num As Integer = 0 To indexcount - 1
            indexnum = selectindx(num)   'チェックしたインデックスの値の取得

            'AxWindowsMediaPlayer1に再生するファイルの登録
            AxWindowsMediaPlayer1.currentPlaylist.appendItem _
                (AxWindowsMediaPlayer1.newMedia(arnme(indexnum)))
        Next

        '停止のメソッド
        dostop()
    End Sub
    '他のプロシージャで使い回しがでkるように再生のメソッドを作成しました。
    Private Sub doplay()
        AxWindowsMediaPlayer1.Ctlcontrols.play()

        '各ボタンの状態の変更
        Button1.Enabled = False
        Button2.Enabled = True
        Button3.Enabled = True
        Button4.Enabled = True
    End Sub
    '停止のメソッド
    Private Sub dostop()
        'このイベントが発生した場合演奏をストップする
        AxWindowsMediaPlayer1.Ctlcontrols.stop()

        '各ボタンの状態の変更
        Button1.Enabled = True
        Button2.Enabled = False
        Button3.Enabled = False
        Button4.Enabled = False
    End Sub
    'PictureBox1_MouseDownイベント
    Private Sub PictureBox1_MouseDown(sender As Object, e As MouseEventArgs) Handles PictureBox1.MouseDown
        'マウスの左ボタンの時の処理
        If e.Button = Windows.Forms.MouseButtons.Left Then
            maderad.mousdown(space1, e.X, e.Y)
            PictureBox1.Image = space1
        End If
    End Sub
    'PictureBox1_MouseUpイベント
    Private Sub PictureBox1_MouseUp(sender As Object, e As MouseEventArgs) Handles PictureBox1.MouseUp
        'RadioButtonの状態によって処理を分ける
        If maderad.bool = False Then
            If e.Button = Windows.Forms.MouseButtons.Left Then
                maderad.mousup(space1, e.X, e.Y)
                PictureBox1.Image = space1
            End If
        ElseIf maderad.bool = True Then
            pictrad()

            ' f()
        End If
    End Sub
    'PictureBox2_MouseEnterイベント
    Private Sub PictureBox2_MouseEnter(sender As Object, e As EventArgs) Handles PictureBox2.MouseEnter
        maderad.mousdown(space1, 8, 8)
        PictureBox1.Image = space1
    End Sub
    'PictureBox2_MouseLeaveイベント
    Private Sub PictureBox2_MouseLeave(sender As Object, e As EventArgs) Handles PictureBox2.MouseLeave
        'RadioButtonの状態によって処理を分ける
        If maderad.bool = False Then
            pictrad()

            ' f()
        ElseIf maderad.bool = True Then
            pictrad()

            ' f()
            maderad.mousup(space1, 8, 8)
        End If
    End Sub
    'RadioButtonをPictureBoxに表示するメソッド
    Private Sub pictrad()
        maderad.sze = sz             'PictureBox1.SizeをClass radbtnに渡すボタンの大きさの参考にする
        maderad.str = cntrlnme       'RadioButtonのラベルの値（今回は"RadioButton3"）を代入

        'PictureBoxのサイズを決定
        PictureBox1.Size = New Size(sz, sz)
        PictureBox2.Size = New Size(szex, szey)

        'PictureBoxの位置を決定
        PictureBox1.Location = New Point(pictx1, picty1)
        PictureBox2.Location = New Point(pictx2, picty2)

        'Bitmapオブジェクトを作成
        space1 = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        space2 = New Bitmap(PictureBox2.Width, PictureBox2.Height)

        'BitmapオブジェクトをClass radbtnに渡す
        maderad.fast(space1)
        maderad.strprint(space2)

        'PictureBoxに表示
        PictureBox1.Image = space1
        PictureBox2.Image = space2

    End Sub

End Class
